unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TfrmMain = class(TForm)
    btnWPM: TButton;
    btnCheckHook: TButton;
    btnAbout: TButton;
    btnClose: TButton;
    imgIcon: TImage;
    lbl: TLabel;
    procedure btnWPMClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCheckHookClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
function DetectSpy:boolean;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

function DetectSpy:boolean;
var hKernel, wpm: Cardinal;
begin
        { Trainer Spy check - checks if "TRAINER SPY" window exists }
        Result := FALSE;
        if FindWindow('#32770', 'TRAINER SPY') <> 0 then Result:=TRUE;
        { EAT check - checks that WriteProcessMemory entry is inside kernel32 }
        hKernel := GetModuleHandle('kernel32');
        wpm := Cardinal(GetProcAddress(hKernel, 'WriteProcessMemory'));
        if ((wpm And $FFF00000) <> (hKernel And $FFF00000)) then Result:=TRUE;
        { IAT check - checks that IAT entry of WriteProcessMemory is same as GetProcAddress() return value }
        if ((PCardinal(PCardinal(Cardinal(PCardinal(@WriteProcessMemory))+2)^)^) <> wpm) then Result:=TRUE;
        { Breakpoint check - checks that WriteProcessMemory code begins with "push ebp" - 55h }
        if ((PCardinal(wpm)^ And $000000FF) <> $00000055) then Result:=TRUE;
end;
procedure TfrmMain.btnWPMClick(Sender: TObject);
var x: Cardinal;
begin
        { dummy WriteProcessMemory() call }
        x := 0;
        WriteProcessMemory(x, Ptr(x), Ptr(x), x, x);
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
        Close;
end;

procedure TfrmMain.btnCheckHookClick(Sender: TObject);
begin
        if DetectSpy = TRUE then
                Application.MessageBox('Spying hooks detected!', 'DetectSpy', MB_OK Or MB_ICONEXCLAMATION Or MB_OK)
        else
                Application.MessageBox('No spying hooks detected.', 'DetectSpy', MB_OK Or MB_ICONINFORMATION Or MB_OK)
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
        Application.MessageBox('Detect Spy' + #13#10 + 'Version 1.0' + #13#10 + 'Coded by comrade <comrade2k@hotmail.com>' + #13#10 + 'Web: http://euro.comrade64.com/' + #13#10 + 'http://comrade64.cjb.net/' + #13#10 + 'http://comrade.ownz.com/' + #13#10 + 'http://comrade.win32asm.com/' + #13#10 + 'http://comrade.hpacv.dk/' + #13#10 + 'http://www.comrade64.com/' + #13#10 + 'IRC: #asm, #coders, #win32asm on EFnet', 'DetectSpy', MB_OK Or MB_ICONINFORMATION Or MB_OK)
end;

end.
